
char label = 0;
char tron = 0;
char echo = 0;
char debug = 0;
char quiet = 0;

char *datav[] = {
  "REM",
  "ATTR",
  "AUDIO",
  "BACKUP",
  "CIRCLE",
  "CLEAR",
  "CLOAD",
  "CLOADM",
  "CLOSE",
  "CLS",
  "COLOR",
  "CONSTANT",
  "CONT",
  "COPY",
  "CSAVE",
  "CSAVEM",
  "DATA",
  "DEF",
  "DEFUSR",
  "DEL",
  "DIM",
  "DIR",
  "DLOAD",
  "DRAW",
  "DRIVE",
  "DSKI$",
  "DSKINI",
  "DSKO$",
  "EDIT",
  "END",
  "EXEC",
  "FIELD",
  "FILES",
  "FN",
  "FOR",
  "GET",
  "GOSUB",
  "GOTO",
  "HBUFF",
  "HCIRCLE",
  "HCLS",
  "HCOLOR",
  "HDRAW",
  "HGET",
  "HLINE",
  "HPAINT",
  "HPRINT",
  "HPUT",
  "HRESET",
  "HSCREEN",
  "HSET",
  "HSTAT",
  "IF",
  "INPUT",
  "KILL",
  "LET",
  "LINE",
  "LIST",
  "LLIST",
  "LOCATE",
  "LPOKE",
  "LOAD",
  "LOADM",
  "LSET",
  "MERGE",
  "MOTOR",
  "NEW",
  "NEXT",
  "OLD",
  "ON",
  "OPEN",
  "PAINT",
  "PALETTE",
  "PCLEAR",
  "PCLS",
  "PCOPY",
  "PLAY",
  "PMODE",
  "POKE",
  "PRESET",
  "PRINT",
  "PSET",
  "PUT",
  "READ",
  "RENAME",
  "RENUM",
  "RESET",
  "RSET",
  "RESTORE",
  "RESUME",
  "RETURN",
  "RUN",
  "SAVE",
  "SAVEM",
  "SCREEN",
  "SET",
  "SKIPF",
  "SOUND",
  "STOP",
  "TO",
  "TROFF",
  "TRON",
  "WIDTH",
  "WRITE",
  "UNLOAD",
  "VERIFY",
  "MEM",
  "TIMER",
  "AND",
  "NOT",
  "OR",
  "ELSE",
  "STEP",
  "FREE",
  "AS",
  "BRK",
  "ERR",
  "CMP",
  "RGB",
  "USING",
  "ERROR",
  "FREE",
  "OFF",
  "TAB",
  "USING",
  "THEN",
  "TO",
  "G",
  "BF",
  "B",
  "R",
  "A",
  "?",
  "AS",
  "BF",
  "OR",
  "PI",
  "",
  "ABS",
  "ASC",
  "ATN",
  "BUTTON",
  "CHR$",
  "COS",
  "CVN",
  "EOF",
  "ERLIN",
  "ERNO",
  "EXP",
  "FIX",
  "HEX$",
  "HPOINT",
  "INKEY$",
  "INSTR",
  "INT",
  "JOYSTK",
  "LEFT$",
  "LEN",
  "LOC",
  "LOF",
  "LOG",
  "LPEEK",
  "MID$",
  "MKN$",
  "PEEK",
  "POINT",
  "POS",
  "PPOINT",
  "RIGHT$",
  "RND",
  "SGN",
  "SIN",
  "STRING$",
  "STR$",
  "SQR",
  "TAN",
  "USR",
  "VAL",
  "VARPTR",
  "\\",
  "AS",
  "BF",
  "FN",
  "IF",
  "ON",
  "OR",
  "PI",
  "TO",
  "\\"
};

int i;
char eof = 0;
int intch = 0;
int datac = 0;
int back;
int forvar;
int switcher;
char temp$[300];
char chrs$[256][2];
char qline$[1000];
char *qlineP$;
int *tempP;
char *fileoutname;

FILE *file_i;
FILE *file_o;
FILE *bug;

char error(char *mesg) {
  printf(mesg);
//  fprintf(bug, mesg);
  return 0;
}

int parse(int argc, char **argv) {
  for (i=2; i<argc; i++) {
    if (!strcmp(argv[i], "-l"))  OUTPUT_LISTING = TRUE;
    if (!strcmp(argv[i], "-x"))  OUTPUT_XREF = TRUE;
    if (!strcmp(argv[i], "-q"))  quiet = TRUE;
    if (argv[i][0]=='-' && argv[i][1]=='o')
      fileoutname = argv[i]+2;
  }
}


int instr(char *in_line, char *word) {
  int len;
  char *fromP;
  char *toP;
  char line[300];
  fromP = in_line;
  toP = line;
  while (*toP++ = *fromP++);
  len = strlen(word);
  for (i=strlen(line)-len; i>0; i--) {
    line[i+len] = 0;
    if (!strcmp(word, line+i))  break;
  }
  return i;
}

int input(char *in_line) {
  char *charP;
  charP = in_line;
  if (intch!=EOF) intch = fgetc(file_i);
  while (intch!=EOF && intch!=10) {
    *charP++ = intch;
    intch = fgetc(file_i);
  }
  *charP = 0;
  if (intch==EOF) {
    eof = NUM_M1;
    intch = 0;
  }
  else  eof = 0;
}

int asc(char *string) {
  return string[0];
}

char *chr$(int val) {
  return chrs$[val];
}

char join(int linenumber, char *to, char *first, char *second) {
  char *toP = to;
  char *firstP = first;
  char *secondP = second;
  int i = 0;
  char *mesg;
  mesg = "";
  if (to==second)  mesg = "string order";
  while (*toP++ = *firstP++)  i++;
  toP--;
  while (*toP++ = *secondP++)  if (i++>256)  break;
  if (i<257)  return 0;
  if (!mesg[0])  mesg = "string overflow";
  printf("%d %s %s\n%s", linenumber, mesg, first, second);
  return 1;
}

char let(int linenumber, char *to, char *from) {
  return join(linenumber, to, from, "");
}

int len(char *name) {
  int i = 0;
  while (name[i]) i++;
  return i;
}

char *mid$(char * toP, char *fromP, int begin, int length) {
  let(0, toP, fromP+begin-1);
  if (length)  toP[length] = 0;
  return toP;
}

char *str$(int number) {
  FILE *temp;
  temp = fopen("temp.c", "w");
  fprintf(temp, " %d%c", number, 0);
  fclose(temp);
  fopen("temp.c", "r");
  fscanf(temp, "%s", LNR_$);
  close(temp);
  return LNR_$;
}

char *showquotes(char *fromP) {
  char *toP;
  char quote;
  toP = qline$;
  quote = 0;
  while (*fromP) {
//    if (*fromP=='"')  quote = 1;
//    if (*fromP=='"' || *fromP=='\\')  *toP++ = '\\';
//    if (quote && *fromP=='\\')  *toP++ = '\\';
//    if (quote && *fromP=='\\')  *toP++ = '\\';
//    if (*fromP=='\\')  quote = 0;
    *toP++ = *fromP++;
  }
  *toP = 0;
  return qline$;
}

int main(int argc, char **argv) {

  int *returnP;
  int returna[10000];
  int *forP;
  int fora[10000];

  returnP = returna;
  forP = fora;

  for (i=0; i<256; i++) {
    chrs$[i][0] = i;
    chrs$[i][1] = 0;
  }

  bug = fopen("bug.bas", "w");

